/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20200110 (64-bit version)
 * Copyright (c) 2000 - 2020 Intel Corporation
 * 
 * Disassembling to symbolic ASL+ operators
 *
 * Disassembly of ssdt15.dat, Thu Feb 13 19:35:20 2020
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00000124 (292)
 *     Revision         0x01
 *     Checksum         0x8A
 *     OEM ID           "HPQOEM"
 *     OEM Table ID     "INSYDE  "
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "ACPI"
 *     Compiler Version 0x00040000 (262144)
 */
DefinitionBlock ("", "SSDT", 1, "HPQOEM", "INSYDE  ", 0x00001000)
{
    External (BID0, UnknownObj)
    External (BID1, UnknownObj)
    External (POS1, UnknownObj)
    External (POS2, UnknownObj)
    External (POS3, UnknownObj)
    External (POS4, UnknownObj)
    External (POS5, UnknownObj)
    External (POSV, UnknownObj)
    External (W10S, UnknownObj)

    Scope (\_SB)
    {
        Device (IPPF)
        {
            Name (_HID, "HPIC0003")  // _HID: Hardware ID
            Method (_STA, 0, NotSerialized)  // _STA: Status
            {
                If ((POS2 == 0x48))
                {
                    Return (0x0F)
                }

                If (((POSV == 0x57) && (POS1 == 0x31)))
                {
                    If (((POS2 == 0x30) && (POS3 == 0x52)))
                    {
                        If (((POS4 == 0x53) && (POS5 == 0x34)))
                        {
                            If ((W10S == One))
                            {
                                Return (0x0F)
                            }
                        }
                    }
                }

                If (((POSV == 0x57) && (POS1 == 0x31)))
                {
                    If (((POS2 == 0x30) && (POS3 == 0x52)))
                    {
                        If (((POS4 == 0x53) && (POS5 == 0x35)))
                        {
                            Return (0x0F)
                        }
                    }
                }

                If (((BID0 == 0x31) && (BID1 == 0x39)))
                {
                    Return (0x0F)
                }

                Return (Zero)
            }
        }
    }
}

